/**
 * Created by EX-HUANGZHIWEI001 on 2015-11-26.
 */
require([ ],
    function() {
        var trRecords = FView.extend({
            list: {},
            events: {
                'blur #email': 'email_Blur', //失焦
                'focus #email': 'email_Focus',//获焦

                'blur #address': 'address_Blur', //失焦
                'focus #address': 'address_Focus',//获焦

                'tap #nextStep': 'nextStep_Tap'//下一步
            },
            init: function() {
                Hyperion.actions.setHeader({
                    title: '账户详情',
                    isBack: true,
                    backCallback: function() {
                        Hyperion.actions.back();
                    },
                    isClose: false,
                    closeCallback: function() {
                        Hyperion.actions.back();
                    }
                });
                var self = this;
                this.getUserInfo(function (userInfo) {//获取登录信息
                    // 处理方法
                    self.list.birthDate = userInfo.birthDate;//生日
                    self.list.cnName = userInfo.cnName;//名字
                    self.list.idType = userInfo.idType;//类型
                    self.list.sex = userInfo.sex;//性别
                    self.list.idNo = userInfo.idNo;//证件号码
                });
                //获取上个页面的信息
                //$('#mobilePhone').text(self.query.mobileNo);//手机号码
                //$('#obligate').text();//预留信息
            },
            handlers: {
                'email_Blur': function() {
                    var myreg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
                    var email = $('#email').val();
                    var address = $('#address').val();

                    if (myreg.test(email) === true && address !== '') {
                        $('#nextStep').addClass('active');
                    } else if (email === '') {
                        Hyperion.actions.tip({'text': '请输入邮箱地址'});
                    } else if (myreg.test(email) === false) {
                        Hyperion.actions.tip({'text': '邮箱格式错误'});
                    } else {
                        $('#nextStep').removeClass('active');
                    }
                },
                'email_Focus': function() {
                    $('#nextStep').removeClass('active');

                },
                'address_Blur': function() {
                    var myreg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
                    var email = $('#email').val();
                    var address = $('#address').val();
                    if (myreg.test(email) === true && address !== '') {
                        $('#nextStep').addClass('active');
                    } else if (address !== '' && email === '') {
                        Hyperion.actions.tip({'text': '请输入邮箱地址'});
                    } else if (address === '') {
                        Hyperion.actions.tip({'text': '地址不能为空'});
                    } else if (myreg.test(email) === false) {
                        Hyperion.actions.tip({'text': '邮箱格式错误'});
                    } else {
                        $('#nextStep').removeClass('active');
                    }
                },
                'address_Focus': function() {
                    $('#nextStep').removeClass('active');
                },
                'nextStep_Tap': function() {//点击下一步确认提交
                    /*this.request({
                     url :'/btoa/work/setting/updateUserInfo',
                     type:'get',
                     data:{//通过登录信息获取到
                     'cnName':this.list.cnName,//姓名
                     'sex':this.list.sex,//性别
                     'idType':this.list.idType,//证件类型
                     'idNo':this.list.idNo,//证件号码
                     'birthDate':this.list.birthDate,//生日
                     'information':''//预留信息
                     },
                     success : function(data){
                     console.log(data);//{"code":"000000","data":{"timestamp":"1448335733061"},"msg":"成功"}
                     if(JSON.parse(data).code === '000000'){
                     Hyperion.actions.forward({
                     url:'modules/account-details/1.0.0/views/myAccount.html'//修改成功跳转到我的账户首页
                     });
                     }
                     },
                     error : function(err){
                     console.log(err);
                     }
                     });*/
                }
            }

        });
        new trRecords();
    });