/**
 * Created by EX-LIXIN601 on 2015-11-27.
 */
require([], function() {
    var self = this;
    var DetailView = FView.extend({
        events: {
            'tap #bt.active': 'do_submit',
            'tap #t1': 'do_forward',
            'tap #p1': 'doActive',
            'tap #p2': 'doActive',
            'tap #m1': 'doActive',
            'tap #m2': 'doActive'
        },
        handlers: {
            doActive: function(event, el) {
                el.parent().parent().find(".button-btn").removeClass("active");
                el.addClass("active");
                if (($('#p1').hasClass('active') || $('#m1').hasClass('active')) && ($('#p2').hasClass('active') || $('#m2').hasClass('active'))) {
                    $('#bt').addClass('active');
                } else {
                    $('#bt').removeClass('active');
                }
            },
            do_forward: function() {
                Hyperion.actions.forward({
                    url: 'modules/licai/1.0.0/views/licai-description.html'
                });
            },
            do_submit: function() {
                Hyperion.actions.onEvent({ eventId:"红棉理财购买_协议确认页", eventLable:"点击下一步" });
                if ($('#m1').hasClass('active')) {
                    Hyperion.actions.tip({text: '未通过产品合适度评估，首次购买理财产品请在柜台办理。'});
                    return;
                } else {
                    if ($('#m2').hasClass('active')) {
                        Hyperion.actions.tip({text: '未通过产品合适度评估，您还不了解理财产品的风险和收益特性，不适合购买。'});
                        return;
                    }
                }
                Hyperion.actions.forward({
                    url: 'modules/licai/1.0.0/views/licai-pay.html'
                });
            }
        },
        init: function() {
            var self = this;
            self.setHeader();
            
        },
        setHeader: function() {
            Hyperion.actions.setHeader({
                isBack: true,
                backCallback: function() {
                    Hyperion.actions.onEvent({ eventId:"红棉理财购买_协议确认页", eventLable:"点击返回" });
                    Hyperion.actions.back();
                },
                isClose: true,
                closeCallback: function() {
                    Hyperion.actions.onEvent({ eventId:"红棉理财购买_协议确认页", eventLable:"点击关闭" });
                    Hyperion.actions.close();
                }
            });
        }
    });
    new DetailView();
});

