/**
 * Created by EX-LIXIN601 on 2015-11-27.
 */
require([
    'text!modules/licai/1.0.0/views/licai-buy-tpl.html'
], function (buy) {
    var self = this;
    var licaiOb = {};
    var DetailView = FView.extend({
        events: {
            'tap #bt.active': 'do_submit',
            'blur #money': 'do_fillMoney'
        },
        handlers: {
            do_fillMoney: function() {
                var money = $('#money').val();
                if (money) {
                    $('#bt').addClass('active');
                } else {
                    $('#bt').removeClass('active');
                }
                if (money < 50000 || money % 10000 !== 0) {
                    Hyperion.actions.tip({text: '认购起点为50000，且必须以万元为倍数!'});
                    $('#bt').removeClass('active');
                }
            },
            do_submit: function() {
                var money = $('#money').val();
                //var flag = parseInt(money, 10) > parseInt(licaiOb.investmentAmount, 10);
                //console.log(licaiOb);
                //if (flag) {
                //    Hyperion.actions.tip({text: '认购金额大于认购余额'});
                //    return;
                //}
                licaiOb.money = $('#money').val();

                Hyperion.actions.setData({
                        name: 'licai',
                        value: licaiOb
                    },
                    function() {
                        Hyperion.actions.forward({
                            url: 'modules/licai/1.0.0/views/licai-pay.html',
                            title: '支付页面'
                        });
                    }
                );
            }
        },
        init: function() {
            var self = this;
            //设置头部
            self.setHeader();
            Hyperion.actions.getData(
                {name: 'licaiList'},
                function (err, d) {
                    console.log(d);
                    licaiOb = d;
                    self.renderBuy(d);
                }
            );
        },
        setHeader: function() {
            Hyperion.actions.setHeader({
                title: '红棉理财',
                isBack: true,
                backCallback: function() {
                    Hyperion.actions.back();
                },
                isClose: true,
                closeCallback: function() {
                    Hyperion.actions.close();
                }
            });
        },
        renderBuy: function (d) {
            this.render(template.compile(buy), {
                data: d
            }, $('#tpl'));
        }
    });
    new DetailView();
});

