require([
    'text!modules/licai/1.0.0/views/licai-details-tpl.html'
    //'modules/licai-recommend/1.0.0/views/detail.tpl',
    //'modules/licai-recommend/1.0.0/data/detail.mock'
], function (detailTpl) {
    var isDev = true,
        Urls = isDev ? {
            detailUrl: "../data/detail.json"
        } : {
            detailUrl: "/toa/x.do"
        },
        Urls2 = isDev ? {
            detailUrl: "../data/detail2.json"
        } : {
            detailUrl: "/toa/x.do"
        };
    var self = this;
    //接收相对应的对象
    var licaiOb = {};
    var DetailView = FView.extend({
        events: {
            'tap #bt': 'do_submit'
        },
        handlers: {
            do_submit: function() {
                Hyperion.actions.onEvent({ eventId:"红棉理财购买_详情页", eventLable:"立即申购" });
                self.getUserInfo(function (userInfo) {
                    if (userInfo) {
                        console.log(userInfo);
                        //代表用户未开户
                        if (userInfo.userType !== '2') {
                            Hyperion.actions.forward({
                                url: 'modules/open-account/1.0.0/views/dredgeDirectSalBank.html',
                                data: {
                                    source: "licai"
                                }
                            });
                        } else {
                            self.checkBindCard(function (isBind) {
                                if (isBind) {
                                    //判断用户风险评估等级
                                    self.shenGou();
                                } else {
                                    Hyperion.actions.forward({
                                        url: 'modules/bind-card/1.0.0/views/bindCard.html',
                                        data: {
                                            source: "licai"
                                        }
                                    });
                                }
                            });
                        }
                    } else {
                        //跳转到登陆界面
                        Hyperion.actions.forward({
                            url: 'app://ff/login',
                            type: 'native'
                        });
                    }
                })
            }
        },
        init: function() {
            self = this;
            // 取参数this.query.id赋值给productId
            self.productId = self.query.id;
            //设置头部
            self.setHeader();
            ////获取理财列表
            //self.getPrdList();
            Hyperion.actions.getData(
                {name: 'licaiProduct'},
                function (err, d) {
                    console.log(d);
                    licaiOb = d;
                    self.renderDetai(licaiOb);
                }
            );
        },
        setHeader: function() {
            Hyperion.actions.setHeader({
                title: '红棉理财',
                isBack: true,
                backCallback: function() {
                    Hyperion.actions.onEvent({ eventId:"红棉理财购买_详情页", eventLable:"点击返回" });
                    Hyperion.actions.back();
                },
                isClose: true,
                closeCallback: function() {
                    Hyperion.actions.onEvent({ eventId:"红棉理财购买_详情页", eventLable:"点击关闭" });
                    Hyperion.actions.close();
                }
            });
        },
        // 检测是否绑卡
        checkBindCard: function (callback) {
            this.request({
                url: "/btoa/work/account/getBindCardList",
                type: "get",
                success: function (res) {
                    if (res.code === "000000") {
                        // bind success
                        if (res.data && res.data.cardList && res.data.cardList.length) {
                            //判断用户是否认证
                            if(res.data.cardList[0].cardStatus === '1'){
                                callback(true);
                            }else{
                                Hyperion.actions.alert(
                                    {
                                        text:'您绑定的银行卡尚未认证，请向电子转账一笔任意数额的资金，转账成功后在30天内登录，系统将自动为您认证。',
                                        btnText:'确定',
                                        btnCallback:function(){
                                        }

                                    },function(){

                                    }
                                );
                            }
                        }
                        // bind empty
                        else {
                            callback(false);
                        }
                    } else {
                        callback(false);
                    }
                }
            });
        },
        //判断用户风险评估等级
        shenGou: function() {
            self = this;
            self.request({
                url: '/btoa/work/finance/gz/getCustRisk',
                //debug: isDev,
                data: {
                    flag: 0
                },
                success: function (res) {
                    console.log(licaiOb);
                    console.log(res);
                    if (res.code === '000000' && res.data) {
                        if (res.data.setFlag === '0' || (res.data.setFlag === '1' && res.data.riskState === '1')) {
                            Hyperion.actions.forward({
                                url: 'modules/licai/1.0.0/views/licai-error.html',
                                data: {
                                    setFlag: res.data.setFlag,
                                    riskState: res.data.riskState
                                }
                            });
                        } else {
                            var flag = parseInt(res.data.riskType) >= parseInt(licaiOb.riskeyType);
                            //保险型
                            if (flag) {
                                Hyperion.actions.setData({
                                        name: 'licaiList',
                                        value: licaiOb
                                    },
                                    function() {
                                        Hyperion.actions.forward({
                                            url: 'modules/licai/1.0.0/views/licai-agree.html'
                                        });
                                    }
                                );
                            } else {
                                Hyperion.actions.tip({text: '您评估的风险等级不适合购买此理财产品!'});
                            }
                        }
                    }
                    else {
                        Hyperion.actions.tip({text: res.msg});
                    }
                }
            });
        },
        renderDetai: function (data) {
            console.log(data.productBeginDates);
            if (data.leftAmount === '') {
                data.leftAmount = '接口暂未提供字段';
            }
            var t1 = new Date(FUtil.parseDateStr(data.productBeginDates)).getTime();
            var t2 = new Date(FUtil.parseDateStr(data.productendDates)).getTime();
            var t3 = t2 - t1;
            data.productLimit = Math.floor(t3 / (24 * 3600 * 1000));
            console.log(data);
            data.productBeginDates = new Date(FUtil.parseDateStr(data.productBeginDates)).format('yyyy/MM/dd');
            data.productendDates = new Date(FUtil.parseDateStr(data.productendDates)).format('yyyy/MM/dd');
            data.prospectusStartDates = new Date(FUtil.parseDateStr(data.prospectusStartDates)).format('yyyy/MM/dd');
            data.prospectusEndDates = new Date(FUtil.parseDateStr(data.prospectusEndDates)).format('yyyy/MM/dd');
            if (data) {
                console.log(data.investmentAmount);
                data.investmentAmount =parseInt(data.investmentAmount).toLocaleString();
                console.log(data.investmentAmount);
                this.render(template.compile(detailTpl), {
                    data: data
                }, $('#detel'));
            } else {
                alert('文章不存在或已被删除！');
                Hyperion.actions.back();
            }
        }
    });
    new DetailView();
});

