/**
 * Created by EX-LIXIN601 on 2015-11-27.
 */
require([
    'text!modules/licai/1.0.0/views/licai-pay-tpl.html'
    //'text!modules/licai-recommend/1.0.0/data/detail.mock'
], function (pay) {
    var time = '59';
    var self = this;
    var licaiOb = [],
        userInfo = {};
    var isDev = true,
        Urls = isDev ? {
            detailUrl: "../data/detail3.json"
        } : {
            detailUrl: "/toa/x.do"
        };
    var DetailView = FView.extend({
        events: {
            'tap #bt.active': 'do_submit',
            //获取短信验证码
            'tap #getSmsToken.active': 'get_message',
            'blur #bd_SMSPassword': 'do_fillMessage',
            'blur #t1': 'do_fillColor'
        },
        handlers: {
            do_fillColor:function(){
                var money = $('#t1').val(),
                    mess = $('#bd_SMSPassword').val();
                if (money < 50000 || money % 10000 !== 0) {
                    Hyperion.actions.tip({text: '认购起点为50000，且必须以万元为倍数!'});
                    $('#bt').removeClass('active');
                }
                console.log(licaiOb);
                console.log(userInfo.balanceList[0].acAvaBlance);
                var acAvaBlance=userInfo.balanceList[0].acAvaBlance;
                if (parseInt(money) > acAvaBlance) {
                    Hyperion.actions.tip({text: '认购金额不能大于可用余额!'});
                    $('#bt').removeClass('active');
                } else {
                    $('#bt').addClass('active');
                }
                if (money && mess) {
                    $('#bt').addClass('active');
                } else {
                    $('#bt').removeClass('active');
                }
            },
            get_message: function() {
                Hyperion.actions.onEvent({ eventId:"红棉理财购买_录入页", eventLable:"获取验证码" });
                var self = this;
                $("#getSmsToken").removeClass('active');
                self.request({
                    url: '/btoa/work/common/sendSmsOtp',
                    type: 'get',
                    data: {},
                    success: function (data) {
                        Hyperion.actions.tip({text: '发送短信验证码成功!'});
                        self.timeComputeS();
                    },
                    error: function (data) {
                    }
                });
            },
            do_fillMessage: function() {
                var money=$('#t1').val(),
                    mess=$('#bd_SMSPassword').val();
                if(money && mess){
                    $('#bt').addClass('active');
                }else{
                    $('#bt').removeClass('active');
                }
            },
            do_addColor: function() {
                var money = $('#money').val();
                $('#add').find('div .checkbox').addClass('active');
                if (money) {
                    $('#bt').addClass('active');
                }

                Hyperion.actions.forward({
                    url: 'modules/licai/1.0.0/views/errorPage.html'
                });
            },
            do_submit: function() {
                Hyperion.actions.onEvent({ eventId:"红棉理财购买_录入页", eventLable:"点击下一步" });
                console.log(licaiOb);
                var message = $("#bd_SMSPassword").val();
                licaiOb.money=$('#t1').val();
                var del = {
                    productId: licaiOb.productId,
                    productName: licaiOb.productName,
                    smsCode: message,
                    currency: licaiOb.currency,
                    amount: licaiOb.money,
                    proType: licaiOb.productType
                };
                var money = $('#t1').val(),
                    mess = $('#bd_SMSPassword').val();
                var acAvaBlance=userInfo.balanceList[0].acAvaBlance;
                if (parseInt(money) > acAvaBlance) {
                    $('#bt').removeClass('active');
                    Hyperion.actions.tip({text: '认购金额不能大于可用余额!'});
                    return;
                } else {
                    $('#bt').addClass('active');
                }
                if (money && mess) {
                    $('#bt').addClass('active');
                } else {
                    $('#bt').removeClass('active');
                }
                licaiOb.money=$('#t1').val();
                var self = this;
                Hyperion.actions.confirm(
                    {
                        text: '您将支付￥' + licaiOb.money + '购买红棉理财',
                        leftBtnText: '确认',
                        // 左按钮点击回调函数_发送取消认购请求
                        leftBtnCallback: function () {
                            self.request({
                                url: '/btoa/work/finance/gz/productBuy',
                                data: del,
                                //请求成功的回调函数
                                success: function (data) {
                                    if (data.code === "000000") {
                                        // 购买理财成功通知native
                                        Hyperion.actions.notifyNativeEvent({
                                            eventName: "buyFinance",
                                            data: {result: "true"}
                                        });
                                        Hyperion.actions.setData({
                                                name: 'jiaoyiDetails',
                                                value: licaiOb
                                            },
                                            function() {
                                                Hyperion.actions.forward({
                                                    url: 'modules/licai/1.0.0/views/licai-success.html'
                                                });
                                            }
                                        );
                                    } else {
                                        //返回详细信息给用户
                                        Hyperion.actions.tip({
                                            text: data.msg
                                        })
                                    }
                                },
                                //请求失败的回调函数
                                error: function (res) {
                                    Hyperion.actions.tip({
                                        text: res.msg
                                    });
                                }
                            })
                        },
                        rightBtnText: "取消",
                        // 左按钮点击回调函数_关闭confirm按钮
                        rightBtnCallback: function () {
                        }
                    }, function () {
                        //回调函数_没有方法
                    }
                );
            }
        },
        init: function() {
            var self = this;
            //设置头部
            self.setHeader();
            Hyperion.actions.getData(
                {name: 'licaiList'},
                function (err, d) {
                    licaiOb = d;
                    console.log(d);
                    self.getUserInfo(function (userInfo) {
                        licaiOb.cnName = userInfo.cnName;
                        //获取账号可用余额
                        self.getElecAccountInfo(licaiOb);
                    });
                }
            );
        },
        setHeader: function() {
            Hyperion.actions.setHeader({
                title: '申购付款',
                isBack: true,
                backCallback: function() {
                    Hyperion.actions.onEvent({ eventId:"红棉理财购买_录入页", eventLable:"点击返回" });
                    Hyperion.actions.back();
                },
                isClose: true,
                closeCallback: function() {
                    Hyperion.actions.onEvent({ eventId:"红棉理财购买_录入页", eventLable:"点击关闭" });
                    Hyperion.actions.close();
                }
            });
        },
        getElecAccountInfo: function (d) {
            self = this;
            console.log(d);
            this.request({
                url: '/btoa/work/account/getElecAccountInfo',
                success: function (res) {
                    d.res = res.data;
                    userInfo = res.data;
                    d.res.acNo = FUtil.encryptAcNo(res.data.acNo);
                    if (res.code === '000000' && res.data) {
                        self.render(template.compile(pay), {
                            data: d
                        }, $('#tpl'));
                    }else{
                        Hyperion.actions.tip({
                            text: res.msg
                        })
                    }
                }
            });
        },
        timeComputeS: function() {
            var self = this;
            if (time === 0) {
                time = 59;
                $('#getSmsToken').addClass('active');
                $("#SMSSendDelay").hide();
                $("#getSmsToken").html("重新获取");
                $("#getSmsToken").show();
            } else {
                $("#getSmsToken").hide();
                $("#SMSSendDelay").show();
                $("#SMSSendDelay").html(time + "秒后重新获取");
                time--;
                setTimeout(function () {
                    self.timeComputeS();
                }, 1000);
            }
        }
    });
    new DetailView();
});

