require([
        'text!modules/licai/1.0.0/views/licai-position-tpl.html'
    ],
    function (detailTpl) {
        // isDev 是否为开发模式
        var liCaiListData = {};        //获取数据的全局变量
        var isDev = false,
            Urls = isDev ? {
                detailUrl: "../data/package.json"
            } : {
                detailUrl: "/toa/x.do",
                serverTimeUrl: "/btoa/portal/common/getTimestamp",
                getBankList: "/btoa/portal/account/getBankList",///btoa/work/finance/getCustRisk
                getCustRisk: "/btoa/work/finance/gz/getCustRisk"

            };
        var DetailView = FView.extend({
            events: {
                "tap #cancel": "e_cancel"                //取消认购
                // "tap #additional":"e_additional"         //追加认购
            },
            init: function () {
                var self = this;
                // 取参数this.query.id赋值给productId
                self.productId = this.query.id;
                // 设置title
                Hyperion.actions.setHeader({
                    title: '稳进帐',
                    isBack: true,
                    backCallback: function () {
                        Hyperion.actions.onEvent({eventId: "10202-我的理财_详情页", eventLable: "1020201-点击“返回”"});
                        Hyperion.actions.back();
                    },
                    isClose: true,
                    closeCallback: function () {
                        Hyperion.actions.onEvent({eventId: "10202-我的理财_详情页", eventLable: "1020202-点击“关闭”"});
                        Hyperion.actions.close();
                    }
                });
                this.getDetailData();
            },
            //获取一些额外帐户信息
            getSomeSmsToken: function () {
                var data = null, self = this;
                this.request({
                    debug: isDev,
                    url: Urls.detailUrl,
                    type: "get",
                    data: {
                        //otpType
                    },
                    //请求成功的回调函数
                    success: function (data) {
                        console.log("获取验证码成功");
                    },
                    //请求失败的回调函数
                    error: function (data) {
                        console.log(data);
                        Hyperion.actions.tip({
                            text: data.msg
                        });
                    }

                });
            },
            // 获取详情数据
            getDetailData: function (callback) {
                var detailsData = null, self = this, beginDate, riskType;
                /*
                 Hyperion.actions.getData({name:'licaiProduct'},function (err, d) {
                 console.log(d);
                 });
                 */
                Hyperion.actions.getData(
                    {name: 'myLicai'},
                    //'myLicai',
                    function (r, d) {
                        detailsData = d.detailData;
                        detailsData.instrt = FUtil.formatCurrency(detailsData.instrt);//转换年化率
                        detailsData.beginDate = detailsData.beginDate.replace(/^(\d{4})(\d{2})(\d{2})$/, "$1/$2/$3");
                        detailsData.buyBeginTime = detailsData.beginDate.replace(/^(\d{4})(\d{2})(\d{2})$/, "$1/$2/$3");
                        //    if(beginDate.length == 8){
                        //        data.beginDate=data.beginDate.substring(0, 4) + "/" + data.beginDate.substring(4, 6) + "/" + beginDate.substring(6, 8);
                        //    }
                        //if(buyBeginTime.length==8){
                        //    buyBeginTime= buyBeginTime.substring(0, 4) + "/" + buyBeginTime.substring(4, 6) + "/" + buyBeginTime.substring(6, 8);
                        //}
                        //查风险等级
                        self.request({
                            debug: isDev,
                            url: Urls.getCustRisk,
                            success: function (data) {
                                if (data && data.data.riskType) {
                                    var map = ['', '保守型', '安稳型', '稳健型', '成长型', '积极型'];
                                    riskType = data.data.riskType;
                                    //var map={'1':'保守型','2':'安稳型'};
                                    //console.log(riskType);
                                    detailsData.riskType = map[riskType];
                                }
                                //获取服务器时间戳
                                self.request({
                                    url: Urls.serverTimeUrl,
                                    debug: isDev,
                                    success: function (res) {
                                        var time = (res.data && res.data.timestamp) ? parseInt(res.data.timestamp) : new Date().getTime();
                                        var nowtime = new Date(time);  //  换成服务器时间戳 请求接口
                                        beginDate = new Date(detailsData.beginDate).getTime();
                                        if (beginDate >= nowtime) {
                                            //可以取消认购
                                            console.log("模板数据1");
                                            console.log(detailsData)
                                            self.renderDetai(detailsData);
                                            liCaiListData = detailsData;
                                            $("#cancelSubscription").css('display', 'block');
                                            $("#notSubscription").css('display', 'none');
                                        } else {
                                            //不可以取消认购
                                            self.renderDetai(detailsData);
                                            liCaiListData = detailsData;
                                            $("#cancelSubscription").css('display', 'none');
                                            $("#notSubscription").css('display', 'block');
                                        }
                                    },
                                    error: function () {
                                    }
                                });
                                //data.riskType=detailsData.riskType;
                                console.log("风险等级");
                                console.log(detailsData.riskType);
                            }, error: function (data) {
                                console.log(data);
                            }
                        });
                    });
            },
            //setHeader: function () {
            //    Hyperion.actions.setHeader({
            //        title: '精选推荐'
            //    });
            //},
            renderDetai: function (data) {
                if (data) {
                    this.render(template.compile(detailTpl), {
                        data: data,
                        moment: $('#a')//容器
                    });
                } else {
                }
            },
            handlers: {
                "e_cancel": function () {
                    //设置埋点需求
                    Hyperion.actions.onEvent({eventId: "10202-我的理财_详情页", eventLable: "1020203-点击“取消认购”"});
                    Hyperion.actions.setData({
                            name: 'detailData',
                            value: liCaiListData
                        },
                        function () {
                            Hyperion.actions.forward({
                                url: "modules/licai/1.0.0/views/licai-cancel.html?as=true"
                                //title: '交易处理成功'
                            });
                        }
                    );
                }
                //"e_additional": function () {
                //    Hyperion.actions.forward({});
                //}
            }
        });
        new DetailView();
    });