require([], function () {
    var time = 59;
    var checkFirst = true;
    var information = {
        'username': false,
        'smstoken': false,
        'idno': false,
        'saverid': true
    };
    var prevData = {};
    var self = this;
    var localData = {};
    var idNoVal;
    var Register = FView.extend({
        source: '',
        events: {
            'blur #CifName': 'blurName',//校验姓名
            'blur #IdNo': 'blurIdNo',//校验身份证
            'input #IdNo': 'E_InputIdNo',
            'input #_SMSToken': 'E_InputSms',
            'tap #getSmsToken.active': 'e_TapSendMessage', //  获取短信验证码
            // 'blur #MobilePhone': 'blurMobilePhone',//校验手机号
            'blur #_SMSToken': 'blurSMSToken',//校验验证码
            'blur #SaverId': 'blurSaverId',//校验介绍人
            'tap #nextStep.error': 'nextStep1',
            'tap #nextStep.active': 'nextStep',//点击下一步,
            'tap #nextStepNo': 'defaultNext',
            'tap #switchSaverId': 'E_tapSwitchSaverId',
            'blur #smsPictureText': 'E_blurSmsPictureText',
            'touchstart .gz-close': 'E_TapClose',
            'tap #sure': 'E_SureTap'
        },
        init: function () {
            self = this;
            self.source = this.query.source;
            this.getRecommendData(function (data) {
                self.setHeader();
                //获取手机号码
                self.getUserInfo(
                    function (d) {
                        console.log(d);
                        localData = d;
                        var $cnName = d.cnName;
                        var $EidNo = d.idNo;

                        if ($cnName && $EidNo) {
                            $('#CifName').val($cnName).prop('disabled', true).css('color', '#666');
                            $('#IdNo').val($EidNo).prop('disabled', true).css('color', '#666');
                            information.idno = true;
                            information.username = true;
                        } else {
                            $('#IdNo').attr('type', 'number');
                            $('#CifName').val('').prop('disabled', false).css('color', '#000');
                            $('#IdNo').val('').prop('disabled', false).css('color', '#000');
                            information.idno = false;
                            information.username = false;
                        }
                    }
                );
                Hyperion.actions.onEvent({ eventId: "10501-开通_身份信息录入页", eventLable: "1050105-跳转来源", BannerName: "升级" });
            });

        },
        getRecommendData: function (cb) {
            if (typeof cb === 'function') {
                cb();
            }
        },
        setHeader: function () {
            /**
             * 通过地址中的参数判断其是否为”承接流程“，还是”单个流程“
             * 1. 单个流程：有返回按钮，有关闭按钮（关闭按钮没有返回上个流程的加逻辑）。
             * 2. 承接流程：没有返回按钮，有关闭按钮（关闭按钮需要加上 返回上个流程的成功页面），
             */
            var hasBackBtn = (this.source === 'licai');
            Hyperion.actions.setHeader(
                {
                    title: '注册直销银行账户',
                    //  返回按钮，需要判断是不是流程内的
                    isBack: hasBackBtn,
                    backCallback: function () {
                        Hyperion.actions.back();
                        Hyperion.actions.onEvent({ eventId: "10501-开通_身份信息录入页", eventLable: "1050101-点击“返回”" });
                    },
                    //  关闭按钮，需要判断是不是流程内的
                    isClose: true,
                    closeCallback: function () {
                        if (hasBackBtn) {
                            $('#closeConfim').show().css("height", $('body')[0].scrollHeight);
                            $('#sure').on('tap', function () {
                                Hyperion.actions.close();
                                Hyperion.actions.onEvent({ eventId: "10501-开通_身份信息录入页", eventLable: "1050102-点击“关闭”" });
                            });
                        } else {
                            Hyperion.actions.close();
                            Hyperion.actions.onEvent({ eventId: "10501-开通_身份信息录入页", eventLable: "1050102-点击“关闭”" });
                        }
                    }
                }, function () {

                }
            );
        },
        //倒计时
        timeComputeS: function () {
            if (time === 0) {
                time = 59;
                $('#getSmsToken').addClass('active');
                $('#smsTip').show();
                $("#getSmsToken").html("重新发送");
            } else {
                $('#smsTip').hide();
                $("#getSmsToken").html(time + "秒后重新获取");
                time--;
                setTimeout(self.timeComputeS, 1000);
            }
        },
        //检查按钮的样式
        enableNextStep: function () {
            /*if (checkFirst) {
             self.init();
             checkFirst = false;
             }*/
            if (information.username && information.smstoken && information.idno && information.saverid) {
                $("#nextStep").removeClass('error');
                $("#nextStep").addClass('active');
            } else {
                $("#nextStep").removeClass('active');
                $("#nextStep").addClass('error');
            }
        },

        //校验真实姓名
        checkName: function (cifName) {
            var reg = /^[\u4e00-\u9fa5]{1,10}$/;
            if (cifName === "" || cifName === null) {
                Hyperion.actions.tip({
                    text: "姓名不能为空",
                    time: 1500
                });
                return false;
            }

            if (!reg.test(cifName) || cifName.length > 10) {
                Hyperion.actions.tip({
                    text: "姓名格式不符",
                    time: 1500
                });
                return false;
            }
            return true;
        },
        //校验身份证号
        checkIdNo: function (idNo) {
            var reg = /(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            var birthday,
                now = new Date();
            if (idNo === "" || idNo === null) {
                Hyperion.actions.tip({
                    text: "身份证格式不符",
                    time: 1500
                });
                return false;
            }
            //比较强验证身份证,基本判定身份格式正确
            if (reg.test(idNo) === false) {
                Hyperion.actions.tip({
                    text: "身份证格式不符",
                    time: 1500
                });
                return false;
            }
            birthday = idNo.length === 18 ? self.stringToDate(idNo.substr(6, 8)) : self.stringToDate('19' + idNo.substr(6, 6));
            var tmp = birthday.after(18, 'year').replace(/-/ig, '/');
            if (self.getTimeDifference(new Date(tmp), now).days < 0) {
                Hyperion.actions.tip({
                    text: "未满十八岁不能注册直销银行",
                    time: 1500
                });
                return false;
            }
            return true;
        },
        checkSMSToken: function (vSMSToken) {
            var reg = /^\d{6}$/;
            if (vSMSToken === null || vSMSToken === "") {
                // Hyperion.actions.tip({text: "请输入6位验证码"});
                return false;
            }

            if (!reg.test(vSMSToken)) {
                Hyperion.actions.tip({
                    text: "请输入6位验证码",
                    time: 1500
                });
                return false;
            }
            return true;
        },
        checkSaver: function (vSaverId) {
            var reg = /^(\d{5})$/,
                regg = /^1\d{10}$/;
            if (vSaverId !== null && vSaverId !== "") {

                if (reg.test(vSaverId) || regg.test(vSaverId)) {
                    return true;
                } else {
                    Hyperion.actions.tip({
                        text: "请输入5位数字或11位手机号码",
                        time: 1500
                    });
                    return false;
                }
            }
            return true;
        },
        stringToDate: function (str) {
            if (str === '' || str === null) {
                return "";
            }
            try {
                var sa = str.split("-");
                if (sa && sa.length < 3) {
                    throw new Error("error");
                }
                var strDate = new Date(sa[0], sa[1] - 1, sa[2]);
                return strDate;
            } catch (e) {
                try {
                    var year = str.slice(0, 4);
                    var month = parseInt(str.slice(4, 6), 10);
                    var day = parseInt(str.slice(6, 8), 10);
                    var strDate = new Date(year, month - 1, day);
                    return strDate;
                } catch (error) {
                    return "日期转换错误";
                }
            }
        },
        getTimeDifference: function (beginDate, endDate) {
            var arr = [];
            arr.years = arr.months = arr.days = arr.hours = arr.mins = arr.diffTime = 0;
            if (beginDate === null || beginDate === "" || beginDate === undefined) {
                return arr;
            }
            if (endDate === null || endDate === "" || endDate === undefined) {
                endDate = new Date();
            }
            // try{
            var diffTime = endDate.getTime() - beginDate.getTime();
            arr.years = endDate.getFullYear() - beginDate.getFullYear();
            arr.months = endDate.getMonth() - beginDate.getMonth() + arr.years * 12;
            arr.days = Math.floor(diffTime / (24 * 3600 * 1000));
            arr.hours = Math.floor(diffTime / (3600 * 1000));
            arr.mins = Math.floor(diffTime / (60 * 1000));
            arr.diffTime = diffTime;
            //  }catch(e){}
            return arr;
        },
        handlers: {
            E_blurSmsPictureText: function () {
                var rightValue = $.trim($('#smsPictureText').val());
                $('#smsPictureText').val(rightValue);
            },
            E_tapSwitchSaverId: function () {
                $('#switchSaverId').parent().hide();
                $('#SaverIdContainer').show();
            },
            defaultNext: function () {

            },
            'E_InputIdNo': function () {
                var $inputVal = $('#IdNo').val().length;
                if ($inputVal === 18) {
                    idNoVal = $('#IdNo').val();
                } else if ($inputVal > 18) {
                    $('#IdNo').val(idNoVal);
                }
            },
            'E_InputSms': function () {
                var $inputVal = $('#_SMSToken').val().length;
                if ($inputVal === 6) {
                    idNoVal = $('#_SMSToken').val();
                } else if ($inputVal > 6) {
                    $('#IdNo').val(idNoVal);
                }
            },
            'E_SureTap': function () {
                Hyperion.actions.onEvent({ eventId: "10504-开通_关闭确认页", eventLable: "1050401-点击“确定”"});
                Hyperion.actions.close();
            },
            blurName: function () {
                information.username = self.checkName($("#CifName").val());
                self.enableNextStep();
            },
            blurIdNo: function () {
                var idNoVal = $.trim($("#IdNo").val());
                $("#IdNo").val(idNoVal);
                information.idno = self.checkIdNo(idNoVal);
                self.enableNextStep();
            },
            'nextStep1': function () {
                Hyperion.actions.tip({
                    text: '请填写正确的信息',
                    time: 1500
                });
            },
            blurSMSToken: function () {
                information.smstoken = self.checkSMSToken($("#_SMSToken").val());
                self.enableNextStep();
            },
            blurSaverId: function () {
                information.saverid = self.checkSaver($("#SaverId").val());
                self.enableNextStep();
            },
            e_TapSendMessage: function () {
                Hyperion.actions.onEvent({ eventId: "10501-开通_身份信息录入页", eventLable: "1050103-点击“获取验证码”" });
                if (!information.idno) {
                    Hyperion.actions.tip({
                        text: '请输入身份证号码',
                        time: 1500
                    });
                    return;
                }
                $("#getSmsToken").removeClass('active');
                self.request({
                    url: '/btoa/work/common/sendSmsOtp',
                    type: 'get',
                    data: {
                        'idNo': $('#IdNo').val(),
                        'otpType': '1',
                        'idType': localData.idType | '1'
                    },
                    success: function (data) {
                        console.log(data);
                        if (data.code !== '000000') {
                            Hyperion.actions.tip({
                                text: '验证发送失败',
                                time: 1500
                            });
                            $('#getSmsToken').addClass('active');
                            return;
                        } else {
                            Hyperion.actions.tip({
                                text: "验证码发送成功",
                                time: 2000
                            });
                            self.timeComputeS();
                        }
                    },
                    error: function (data) {
                        Hyperion.actions.tip({
                            text: '验证发送失败',
                            time: 1500
                        });
                        $('#getSmsToken').addClass('active');
                    }
                });
            },
            'E_TapClose': function (e) {
                e.stopImmediatePropagation();
                e.preventDefault();
                $('#closeConfim').hide();
                Hyperion.actions.onEvent({ eventId: "10504-开通_关闭确认页", eventLable: "1050402-点击“关闭”"});
            },
            //点击下一步
            nextStep: function (e) {
                Hyperion.actions.onEvent({ eventId: "10501-开通_身份信息录入页", eventLable: "1050104-点击“确定，下一步”" });
                e.stopImmediatePropagation();
                //真实姓名
                var cifName = $("#CifName").val(),
                    idNo = $("#IdNo").val(),
                    mobileNo = localData.mobileNo,
                    vSMSToken = $("#_SMSToken").val(),
                    vSaverId = $("#SaverId").val();

                /*self.saveCache();*/

                if (!self.checkName(cifName)) {
                    return false;
                }
                //身份证号
                if (!self.checkIdNo(idNo)) {
                    return false;
                }
                //短信验证码
                if (!self.checkSMSToken(vSMSToken)) {
                    return false;
                }
                //介绍人
                if ((vSaverId === '' || vSaverId === null) && !self.checkSaver(vSaverId)) {
                    return false;
                }
                Hyperion.actions.setData({
                        name: 'openAcount',
                        value: {
                            'cifName': cifName,
                            'idNo': idNo,
                            'mobileNo': mobileNo,
                            'vSMSToken': vSMSToken,
                            'vSaverId': vSaverId,
                            'smsCode': vSMSToken
                        }},
                    function () {
                        Hyperion.actions.forward({
                            url: 'modules/open-account/1.0.0/views/setDeilPwd.html',
                            data: {
                                source: 'licai'
                            }
                        });
                    });
            }
        }
    });
    new Register();
});