/**
 * Created by EX-HUANGZHIWEI001 on 2015-11-26.
 */
require([
        'text!modules/trading-record/1.0.0/views/rendering-tpl.html',
        'text!modules/trading-record/1.0.0/views/err-tpl.html',
        'text!modules/trading-record/1.0.0/views/err01-tpl.html'
    ],

    function (detailTpl, exTpl, exTpl01) {
        //console.log(detailTpl);
        var $head = $('#infom');
        detailTpl = template.compile(detailTpl);
        exTpl = template.compile(exTpl);
        exTpl01 = template.compile(exTpl01);
        var trRecords = FView.extend({
            params: {
                pageNo: 1,   //第几页
                pageSize: 10, //每页显示几条数据
                dataCount: 0, //接口总共返回{}条数据
                searchBy: 0,
                startDate: new Date().getFullYear().toString() + (parseInt(new Date().getMonth()) + 1).toString() + new Date().getDay().toString(),
                endDate: new Date().getFullYear().toString() + (parseInt(new Date().getMonth()) + 1).toString() + new Date().getDay().toString()
            },
            historyData: [],
            events: {
                'tap #today': 'today_Tap',//今天
                'tap #past': 'past_Tap',//过去7天
                'tap #pastD': 'pastD_Tap',//过去30天
                'tap #date': 'date_Tap',//指定日期
                'tap .itemPoint': 'itemPoint_Tap',//支入支出
                'touchstart #touchM': 'touchStart',//开始触摸
                'touchmove #touchM': 'touchMove',//离开
                'touchend #touchM': 'touchEnd'//结束
            },
            clearNativeEvent: function() {
                // 移除iOS - onBack监听
                Hyperion.actions.removeNativeEvent({
                    eventName: "onBackMessage",
                    eventHandler: "onBack"
                });
            },
            init: function() {
                var self = this;
                Hyperion.eventListener.onBack = function() {
                    Hyperion.actions.getData(
                        {name: 'TimeDate'},
                        function (r, d) {
                            var financalTt = d;
                            self.params.calendarDateStart = financalTt.startDateT_;
                            self.params.calendarDateEnd = financalTt.endDateT_;
                            if (typeof self.params.calendarDateStart !== "undefined") {
                                $('ul.head-list li').removeClass("active");
                                var a = self.params.calendarDateStart;
                                var b = a.substring(0, 4);
                                var c = a.substring(5, 7);
                                var d = a.substring(8, 10);
                                var a1 = self.params.calendarDateEnd;
                                var b1 = a1.substring(0, 4);
                                var c1 = a1.substring(5, 7);
                                var d1 = a1.substring(8, 10);
                                //日历带过来的日期时间给qryTrade()方法，然后在该方法里面进行判断日期
                                self.params.startDate = b + c + d;
                                self.params.endDate = b1 + c1 + d1;

                                self.histroyDate = [];
                                self.params.pageNo = 1;
                                $('#dateTime').text(self.params.calendarDateStart + '至' + self.params.calendarDateEnd);
                                //日历页面带回来的日期时间开始发送请求
                                self.qryTrade();
                            }
                        });
                };


                // 添加iOS - onBack监听
                Hyperion.actions.registNativeEvent({
                    eventName: "onBackMessage",
                    eventHandler: "onBack"
                });

                self.params.productId = self.query.transferList;
                Hyperion.actions.setHeader({
                    title: '交易记录',
                    isBack: true,
                    backCallback: function() {
                        Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "点击返回" });
                        self.clearNativeEvent();// 移除iOS - onBack监听
                        Hyperion.actions.back();
                        Hyperion.actions.removeData({//返回自动清除本地日历返回的数据
                            name: 'TimeDate'
                        });
                    },
                    isClose: false,
                    closeCallback: function() {
                        self.clearNativeEvent();// 移除iOS - onBack监听
                        Hyperion.actions.back();
                    }
                });
                self.today();
            },
            qryTrade: function() {
                var self = this;
                var a = self.params.timestamp;//self.params.timestamp 进来页面获取当天的日期时间
                var b = a.substring(0, 4);
                var c = a.substring(5, 7);
                var d = a.substring(8, 10);
                var starDateSys = b + c + d;
                //开始时间等于结束时间 并且 开始时间等于当天时间
                if (self.params.startDate === self.params.endDate && self.params.startDate === starDateSys) {
                    //查询当天记录
                    self.params.searchBy = 0;
                } else {
                    //查询历史记录
                    self.params.searchBy = 1;
                }
                self.request({
                    url: '/btoa/work/account/getTransferInfoList',
                    type: 'get',
                    data: {
                        'beginDate': self.params.startDate,//开始日期
                        'endDate': self.params.endDate,//结束日期
                        'pageNo': self.params.pageNo,//笔序号
                        'pageSize': self.params.pageSize,//笔数
                        'searchBy': self.params.searchBy//0当天 1历史
                    },
                    success: function (res) {
                        //console.log(JSON.stringify(res));
                        /*var res = {"code": "000000", "data": {"bankName": "广州银行", "bankNo": "0272", "cifName": "刘烁彬", "cifNo": "1037286456", "totalNum": "6", "transAcNo": "6214633139500004009", "transferList": [
                         {"amount": "5000000.00", "balance": "5000000.00", "ctFlag": "", "currency": "CNY", "deptId": "0319", "partnerAcName": " 　", "partnerAcNo": "", "partnerId": "", "partnerInfo": "", "remark": "", "summary": "现金", "transDate": "20151127", "transInfo": "", "transTime": "16:01:00", "transType": "C", "trsInfoDetail": "31903005"},
                         {"amount": "11.00", "balance": "4999989.00", "ctFlag": "", "currency": "CNY", "deptId": "0090", "partnerAcName": "刘烁彬 　", "partnerAcNo": "103728645600018", "partnerId": "", "partnerInfo": "环市东支行", "remark": "", "summary": "转帐", "transDate": "20151127", "transInfo": "", "transTime": "16:25:00", "transType": "D", "trsInfoDetail": "44503047"},
                         {"amount": "1.00", "balance": "4999988.00", "ctFlag": "", "currency": "CNY", "deptId": "0090", "partnerAcName": "刘烁彬 　", "partnerAcNo": "103728645600018", "partnerId": "", "partnerInfo": "环市东支行", "remark": "", "summary": "转帐", "transDate": "20151127", "transInfo": "", "transTime": "16:42:00", "transType": "D", "trsInfoDetail": "40903052"},
                         {"amount": "1.00", "balance": "4999987.00", "ctFlag": "", "currency": "CNY", "deptId": "0090", "partnerAcName": "刘烁彬 　", "partnerAcNo": "103728645600018", "partnerId": "", "partnerInfo": "环市东支行", "remark": "", "summary": "转帐", "transDate": "20151127", "transInfo": "", "transTime": "12:30:00", "transType": "D", "trsInfoDetail": "42003047"},
                         {"amount": "1.00", "balance": "4999986.00", "ctFlag": "", "currency": "CNY", "deptId": "0090", "partnerAcName": "刘烁彬 　", "partnerAcNo": "103728645600018", "partnerId": "", "partnerInfo": "环市东支行", "remark": "", "summary": "转帐", "transDate": "20151127", "transInfo": "", "transTime": "12:54:00", "transType": "D", "trsInfoDetail": "40303043"}
                         ]}, "msg": "成功"};*/
//                        self.histroyDate = [];
                        if (res) {
                            if (res.code === '000000' && res && res.data) {

                                self.params.dataCount = res.data.totalNum;
                                if (self.historyData.length < self.params.dataCount) {
                                    self.historyData = self.historyData.concat(res.data.transferList);
                                }
                                for (var i = 0; i < res.data.transferList.length; i++) {
                                    res.data.transferList[i].partnerAcNo = FUtil.encryptAcNo(res.data.transferList[i].partnerAcNo);//partnerAcNo:对方账号

                                }
                                res.data.transAcNo = FUtil.encryptAcNo(res.data.transAcNo);//transAcNo:电子帐户
                                res.data.transferList = self.historyData;
                                self.render(detailTpl, res, $('#infom'));
                            }
                            else if (res && res.data) {
                                self.render(exTpl01, {}, $('#infom'));
                            }
                            else {
                                self.render(exTpl, res, $('#infom'));
                            }
                        }
                        else {
                            //Hyperion.actions.tip({'text': '系统异常'});
                        }
                    },
                    error: function (err) {
                        console.log(err);
                    }
                });
            },
            today: function() {//进来本页初始化，渲染出当天的数据
                var self = this;
                /*
                 * 获取服务器的时间，赋值给self.params.startDate，self.params.endDate
                 */
                this.request({//获取服务时间戳
                    url: '/btoa/portal/common/getTimestamp',
                    type: 'get',
                    success: function (res) {
                        console.log(res);
                        if (res.code === '000000' && res.data) {
                            var timestamp = new Date(parseInt(res.data.timestamp));
                            var year = timestamp.getFullYear() + '/';
                            var month = (timestamp.getMonth() + 1 < 10 ? '0' + (timestamp.getMonth() + 1) : timestamp.getMonth() + 1) + '/';
                            var days = (timestamp.getDate() < 10 ? '0' + (timestamp.getDate()) : timestamp.getDate()) + '';
                            self.params.timestamp = year + month + days;
                            var a = self.params.timestamp;
                            var b = a.substring(0, 4);
                            var c = a.substring(5, 7);
                            var d = a.substring(8, 10);
                            self.params.sumToday = b + c + d;
                            self.params.startDate = self.params.sumToday;
                            self.params.endDate = self.params.sumToday;
                            $('#dateTime').text(self.params.timestamp);
                            self.qryTrade();
                        }
                    },
                    error: function (err) {
                        console.log(err);
                    }
                });
            },
            yesterday: function (days) {
                var self = this;
                var date = new Date();
                var year = date.getFullYear();
                var month = date.getMonth();
                var day = date.getDate();

                self.params.systemTime = new Date(year, month, day);
                (self.params.systemTime).setDate((self.params.systemTime).getDate() - days);//取得系统时间的前一天,负数是前几天,正数是后几天
                var getMonth = (self.params.systemTime).getMonth();
                getMonth++;
                var theMonths = getMonth >= 10 ? getMonth : ("0" + getMonth);
                var getDate = (self.params.systemTime).getDate();
                var theDay = getDate >= 10 ? getDate : ("0" + getDate);
                self.params.systemTime = (self.params.systemTime).getFullYear() + "/" + theMonths + "/" + theDay;

                self.params.systemTimeed = new Date(year, month, day);
                (self.params.systemTimeed).setDate((self.params.systemTimeed).getDate() - 1);
                var getMonthed = (self.params.systemTimeed).getMonth();
                getMonthed++;
                var theMonthsed = getMonthed >= 10 ? getMonthed : ("0" + getMonthed);
                var getDateed = (self.params.systemTimeed).getDate();
                var theDayed = getDateed >= 10 ? getDateed : ("0" + getDateed);
                self.params.systemTimeed = (self.params.systemTimeed).getFullYear() + "/" + theMonthsed + "/" + theDayed;

                $('#dateTime').text(self.params.systemTime + '至' + self.params.systemTimeed);
            },
            handlers: {
                'today_Tap': function (e) {//今天
                    Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "点击今天" });
                    var self = this;
                    var target = e.target, $target = $(target);
                    if (!$target.hasClass('active')) {
                        $('#today').addClass('active');
                        $('#past').removeClass('active');
                        $('#pastD').removeClass('active');
                        $('#dateTime').text(self.params.timestamp);
                        self.historyData = [];
                        self.params.pageNo = 1;
                        self.params.startDate = self.params.sumToday;
                        self.params.endDate = self.params.sumToday;
                        self.qryTrade();
                    }
                },
                'past_Tap': function (e) {//过去7天时间
                    Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "点击过去7天" });
                    var target = e.target, $target = $(target);
                    if (!$target.hasClass('active')) {
                        var self = this;
                        $('#today').removeClass('active');
                        $('#past').addClass('active');
                        $('#pastD').removeClass('active');
                        self.yesterday(7);
                        var a = self.params.systemTime;
                        var b = a.substring(0, 4);
                        var c = a.substring(5, 7);
                        var d = a.substring(8, 10);
                        var a1 = self.params.systemTimeed;
                        var b1 = a1.substring(0, 4);
                        var c1 = a1.substring(5, 7);
                        var d1 = a1.substring(8, 10);
                        self.params.startDate = b + c + d;
                        self.params.endDate = b1 + c1 + d1;
                        self.historyData = [];//清空数组对象数据
                        self.params.pageNo = 1;//默认为1页
                        self.qryTrade();
                        console.log('过去7天的日期 = ' + self.params.systemTime + '至' + self.params.systemTimeed);
                    }
                },
                'pastD_Tap': function (e) {//过去30天时间
                    Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "点击过去30天" });
                    var self = this;
                    var target = e.target, $target = $(target);
                    if (!$target.hasClass('active')) {
                        $('#today').removeClass('active');
                        $('#past').removeClass('active');
                        $('#pastD').addClass('active');
                        self.yesterday(30);
                        var a = self.params.systemTime;
                        var b = a.substring(0, 4);
                        var c = a.substring(5, 7);
                        var d = a.substring(8, 10);
                        var a1 = self.params.systemTimeed;
                        var b1 = a1.substring(0, 4);
                        var c1 = a1.substring(5, 7);
                        var d1 = a1.substring(8, 10);
                        self.params.startDate = b + c + d;
                        self.params.endDate = b1 + c1 + d1;

                        self.historyData = [];//清除数据
                        self.params.pageNo = 1;
                        self.qryTrade();
                        console.log('过去30天的日期 = ' + self.params.systemTime + '至' + self.params.systemTimeed);
                    }
                },
                'date_Tap': function() {//获取当前日期带给日历页
                    Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "点击指定日期" });
                    var self = this;
                    var save = $('#dateTime').text();
                    if (save.length === 10) {
                        self.params.getStartTime = save;
                        self.params.getEndTime = save;
                    } else if (save.length > 10) {
                        self.params.getStartTime = save.substring(0, 10);
                        self.params.getEndTime = save.substring(11, 21);
                    }
                    var a = self.params.getStartTime;
                    var b = a.substring(0, 4);
                    var c = a.substring(5, 7);
                    var d = a.substring(8, 10);
                    var a1 = self.params.getEndTime;
                    var b1 = a1.substring(0, 4);
                    var c1 = a1.substring(5, 7);
                    var d1 = a1.substring(8, 10);
                    self.params.startDates = b + c + d;
                    self.params.endDates = b1 + c1 + d1;


                    // 添加android - onBack监听
                    Hyperion._handlers.onBack = function() {
                        Hyperion.eventListener && Hyperion.eventListener.onBack.apply(this, arguments);
                    };

                    Hyperion.actions.forward({
                        data: {
                            "startTimeDays": self.params.startDates,//开始时间
                            "endTimeDays": self.params.endDates//结束时间
                        },
                        url: 'modules/trading-record/1.0.0/views/calendar.html'
                    });
                },
                'itemPoint_Tap': function (e) {
                    Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "点击展开/收缩详情" });
                    var target = $(e.target);
                    target = target.hasClass("itemPoint") || target.parents(".itemPoint");
                    if (target.next('div.border-btm').hasClass('block')) {
                        $(".list-content").addClass("none").removeClass("block");
                        target.next('div.border-btm').addClass('none').removeClass('block');
                    } else {
                        $(".list-content").addClass("none").removeClass("block");
                        target.next('div.border-btm').addClass('block').removeClass('none');
                    }
                },
                touchEnd: function (ev) {
                    Hyperion.actions.onEvent({ eventId: "交易记录_查询页", eventLable: "上拉刷新" });
                    var self = this;
                    if (self.params.startY - self.params.endY > 15) {
                        var pageNo = self.params.pageNo,//第几页
                            pageSize = self.params.pageSize,//每页显示10条数据
                            dataCount = self.params.dataCount;//接口总共返回{}条数据
                        if (pageNo * pageSize <= dataCount) {
                            self.params.pageNo++;
                            console.log(self.params.pageNo);
                            self.qryTrade();
                        }
                        /* else {
                         console.log("not data");
                         }*/
                    }
                },
                'touchMove': function (ev) {
                    var self = this;
                    self.params.endY = ev.touches[0].clientY;
                },
                'touchStart': function (ev) {
                    var self = this;
                    self.params.startY = ev.touches[0].clientY;
                }
            },
            // 渲染数据
            renderDetai: function (data) {
                if (data) {
                    // 模板填充
                    this.render(detailTpl, {
                        data: data
                    });
                } else {
                    Hyperion.actions.back();
                }
            }
        });
        new trRecords();
    });